/*  
This example generates the all possible numbers that would be
formed using 4 bits and outputs them to GreenPAK Comparator inputs,
then it reads comparator outputs and compares them with the correct 
values
*/
boolean Greater;
boolean Equal;
boolean Less;
byte A_VAR;
byte B_VAR;
boolean Err_flag;
void setup()
{
  Serial.begin(9600);
  for(int i=2;i<10;i++)
  pinMode(i,OUTPUT);   //2,3,4,5 pins for A. 6,7,8,9 pins for B
  pinMode(10,INPUT);   //A>B comparator output
  pinMode(11,INPUT);   //A=B comparator output
  pinMode(12,INPUT);   //A<B comparator output
}
void loop()
{
  for(A_VAR=0;A_VAR<16;A_VAR++)   //A number formation 
  for(B_VAR=0;B_VAR<16;B_VAR++)   //B number formation 
  { // Converting A_VAR, B_VAR to binary and outputting them to GreenPAK inputs.
  digitalWrite(2, HIGH && (A_VAR & B00000001 ));// A0
  digitalWrite(3, HIGH && (A_VAR & B00000010 ));// A1
  digitalWrite(4, HIGH && (A_VAR & B00000100 ));// A2
  digitalWrite(5, HIGH && (A_VAR & B00001000 ));// A3
  digitalWrite(6, HIGH && (B_VAR & B00000001 ));// B0
  digitalWrite(7, HIGH && (B_VAR & B00000010 ));// B1
  digitalWrite(8, HIGH && (B_VAR & B00000100 ));// B2
  digitalWrite(9, HIGH && (B_VAR & B00001000 ));// B3
  delay(10);
   Greater=digitalRead(10); // Read A>B output
   Equal=digitalRead(11);   // Read A=B output
   Less=digitalRead(12);    // Read A<B output
   delay(5);
  if((A_VAR > B_VAR)&& Greater && !Equal && !Less)
  ;  //Correct, move to the next loop
  else if((A_VAR == B_VAR)&& !Greater && Equal && !Less)
  ;  //Correct, move to the next loop
  else if((A_VAR < B_VAR)&& !Greater && !Equal && Less)
  ;  //Correct, move to the next loop
  else
  Serial.print("Error");  // Print error on serial monitor
   Err_flag=1; 
  } 
 if(!Err_flag)
 Serial.println(" Teasting complete...All cases are correct ");
 delay(2000);
}
